#!/bin/bash
# blink.cgi
# created and copyrighted: 29 Jan 11
# author: Evsiz (evsiz@this-voice.org)
# The author releases this file under the GNU GPL
# license. See GNU's COPYING file for specifics.
#

# ========== consts

# uncomment next 2 if you have char problems
#set LANG=C
#export LANG

CGI=/cgi-bin/blink.cgi
CLASS="hangingSubhead" # css for post title
COUNT=12
LOG=blink.log
PRE=  # set to "true" or ""
REMOTE=$HTTP_X_CLUSTER_CLIENT_IP
ROOT=blink  # cgi-bin/blink
SELF="74.78.35.155 x"  # your IP used for admin access
SHORT="true"  # set to "true" or "" 
CYCLES=80000  # actually pages in hosting compute-cycle daily limit
LIMIT="<html><body><center><h3>Daily Host Allotment Reached</h3>
Blog back on-line immediately after midnight US Central Time</html>"
SPAM="fuck 666"
TAGS="true" # set to "true" or ""
TARBALL_DIR=data/private
TEMPLATE="true" # set to "true" or ""

#
# If you use ACCESS, you can see who the bad guys are and put them in
# here. The entries here can be x.x, x.x.x, x.x.x.x.  Try not to ban
# good people.
#
BANNED="65.49.14 59.47.43 x"
RUST="<html><body><center><h3>Access Denied<br>
Subnet Identified As Persistent Spammer</h3>
<p>R.U.S.T. Never Sleeps</html>"

#
# If you use $ACCESS, you must add the IP of posters and commenters
# you wish to allow to use the blog.  Anyone can still make a first
# post or comment.
#
ACCESS="yes"

#
# space between elements - keep x at end of lists
#
COMMENTED_BLOGS="Poor_Richards_Alchemy test x" #allow comments
LINKED=" x" #bold defs and auto linking
OPEN_BLOGS="Poor_Richards_Alchemy test x" #public posts
REVERSED=" x" #oldest post first

#
# run `touch ./.local` for development
#
if [ "$REMOTE" == "" ]; then REMOTE=$REMOTE_ADDR; fi
if [ -f .local  ]; then SELF="127.0.0.1 x";  fi

# ========== methods
next () {
    START=$1
    TOTAL=`ls -1r $ROOT/$BLOGDIR | wc -l`
	TOTAL=`expr $TOTAL + $COUNT`
	NEXT=`expr $START + $COUNT`	
    if [ $NEXT -le $TOTAL ]; then
		true
	else
		NEXT=$COUNT
    fi
	BLOGNAME=`echo $BLOGDIR | tr _ " "`
    echo "<hr><h3>$BLOGNAME continues on the <a href=\""$CGI"?mode=blog&dir="$BLOGDIR"&type=next&start="$NEXT"\">Next Page</a></h3>"
}

parse_val () {
    echo $1 | awk 'BEGIN { RS = "&" } ; \
	{ if (index($0, "'$2'") == 1) { split($0, tmp, "="); print tmp[2]; exit; }};'
}

decode () {
    arg=`echo $1 | awk '{
       gsub(/\%0D\%0A/, "\r") ;
       gsub(/\%0d\%0a/, "\r") ;
       gsub(/\%23/, "#") ;
       gsub(/\x2B/, " ") ;
       gsub(/\x2b/, " ") ;
       print
    }'`
    i="0"
    while [ "$i" -lt ${#arg} ]; do
        c0=${arg:$i:1}
        if [ "x$c0" = "x%" ]; then
            c1=${arg:$((i+1)):1}
            c2=${arg:$((i+2)):1}
            printf "\x$c1$c2"
            i=$((i+3))
        else
            echo -n "$c0"
            i=$((i+1))
        fi
    done

}

do_posts () {
		if [ "$REVERSE" == "okay" ]; then
    	    EXIST=`ls -1r $ROOT/$BLOGDIR | wc -l`
	        if [ $EXIST -1r $COUNT ]; then COUNT=$EXIST; fi
			ENTRIES=`ls -1r $ROOT/$BLOGDIR | tail -n $COUNT`
			for ((a=$COUNT; a > 0; a--)); do
				entry=`echo $ENTRIES | cut -d" " -f $a`
				echo "<hr>"
				cat $ROOT/$BLOGDIR/$entry
				if [ "$COMMENTED" == "okay" ]; then
					comment_link $entry
					do_comments $entry
				fi
				done
		else
			ENTRIES=`ls -1r $ROOT/$BLOGDIR | head -n $COUNT`
			for entry in $ENTRIES; do
				echo "<hr>"
				cat $ROOT/$BLOGDIR/$entry
				if [ "$COMMENTED" == "okay" ]; then
					comment_link $entry
					do_comments $entry
				fi
				done
		fi
		next $COUNT
}

comment_link () {
	echo "<br><a href="$CGI"?mode=blog&dir=$BLOGDIR&type=entry&comment="$1">Comment</a> on this post."
}

despam () {
	BAD=`grep -l http $ROOT/$BLOGDIR/.comments/* 2>/dev/null`
	for bad in $BAD; do
		rm $bad
		TMP=`basename $bad`
		TMP2=`grep -v $TMP $LOG`
		echo $TMP2 | awk '{ gsub("<br>", "\n<br>" ) ; print}'  > $LOG
		done
}

do_comments () {
	COMMENTS=`ls -1t $ROOT/$BLOGDIR/.comments/$1* 2>/dev/null`
	for c in $COMMENTS; do
		echo "<hr align=left width=50%><blockquote>"
		if [ -f $c ]; then cat $c; fi
		echo "</blockquote>"
	done
}

# ========== vars

REQUEST=`echo  "$REQUEST_URI" | cut -d"?" -f2 | tr -d "*" `
MODE=$(parse_val $REQUEST "mode")
BLOGDIR=$(parse_val $REQUEST "dir")
TYPE=$(parse_val $REQUEST "type")
BLOG=`echo $BLOGDIR | tr _ " "`
if [ "$BLOGDIR" == "" ] && [ "$MODE" == "blog" ]; then
    MODE="";
    TYPE="";
    TEMPLATE="";
    fi
if [ ! -d $ROOT/$BLOGDIR ] && [ "$MODE" == "blog" ]; then
    MODE="";
    TYPE="";
    TEMPLATE="";
    fi

REVERSE=`echo $REVERSED | awk 'BEGIN { RS = " " }; \
	{  if ( $0 ~ "'$BLOGDIR'" ) { print "okay"; exit } }'`
OPEN=`echo $OPEN_BLOGS | awk 'BEGIN { RS = " " }; \
	{  if ( $0 ~ "'$BLOGDIR'" ) { print "okay"; exit } }'`
LINK=`echo $LINKED | awk 'BEGIN { RS = " " }; \
	{  if ( $0 ~ "'$BLOGDIR'" ) { print "okay"; exit } }'`
COMMENTED=`echo $COMMENTED_BLOGS | awk 'BEGIN { RS = " " }; \
	{  if ( $0 ~ "'$BLOGDIR'" ) { print "okay"; exit } }'`

# ========== code

echo "Content-Type: text/html

"

#
# Identified spammers
#
ISBANNED=`echo $BANNED | awk 'BEGIN { RS = " " }; { \
	if ( index( "'$REMOTE'", $0 ) == 1 ) { print "banned"; exit } }'`

if [ "$ISBANNED" == "banned" ]; then
	echo $RUST
	exit
fi

#
# spam attempts on no-comment blogs
#
if [ "$COMMENTED" != "okay" ]; then
	CCHK=$(parse_val $REQUEST "comment")
	if [ "$CCHK" != "" ]; then
		echo $RUST
		exit
	fi
fi

#
# spam attempts on non-open blogs
#
if [ "$OPEN" != "okay" ]; then
	OCHK=$(parse_val $REQUEST "fname")
	if [ "$OCHK" != "" ]; then
		echo $RUST
		exit
	fi
fi

#
# begin blog
#

if [ "$MODE" != "admin" ]; then
    if [ -n "$TEMPLATE" ]; then
        cat $ROOT/$BLOGDIR/.head 2>/dev/null
    else
	    echo "<html><head>
<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />
<title>Blink :: "$BLOG"</title></head>
<body><h4>Blink :: <a href=\""$CGI"?mode=blog&dir=$BLOGDIR\">$BLOG</a></h4>"
        if [ -e $ROOT/$BLOGDIR/.header ]; then cat $ROOT/$BLOGDIR/.header; fi
    fi
fi

#
# SHORT is for staying under the hosting compute-cycle limit
#
if [ "$SHORT" == "true" ]; then
	TODAY=`date +%A`
	DAY=`cat short.day`
	echo -n x >> short.txt
	USAGE=`ls -l short.txt | cut -d" " -f5 2>/dev/null`
	if [ "$TODAY" != "$DAY" ]; then
		echo $TODAY > short.day
		rm short.txt
		touch short.txt
	fi
	if [ $USAGE -gt $CYCLES ]; then
		echo $LIMIT
		exit
	fi
fi

#
# Access List.  If in "once," only no writes. Good peoples
# to ALIST, bad stay in once or get moved to BANNED
#

if [ "$ACCESS" == "yes" ] && [ "$TYPE" == "write" ]; then

	INALIST=`grep $REMOTE ./access.lst`
	if [ -f .local  ]; then INALIST=local;  fi
	if [ "$INALIST" == "" ]; then 
		ONCE=`grep ^$REMOTE$ ./once 2>/dev/null`
		if [ "$ONCE" != "" ]; then
			echo "<h3>Access Pending</h3>
Your IP has not yet been entered into the access list.
As noted, the first post or comment cannot be edited.
If your first post remains visible, your IP will be added soon.
If your first post is deleted, the IP will not be added."
			TYPE=""
		else
			echo $REMOTE >> once
		fi
	fi
fi

# middle
if [ "$MODE" == "blog" ]; then
    if [ "$OPEN" == "okay" ]; then
        FNAME=`date +%s`
        echo "<p>This is an open blog.
Submit a <a href="$CGI"?mode=blog&dir="$BLOGDIR"&type=entry&fname="$FNAME" >post</a>."
    fi
	if [ "$TYPE" == "next" ]; then
		START=$(parse_val $REQUEST "start")
		if [ "$START" == "" ]; then
			START=$COUNT
		fi
		TOTAL=`ls -1r $ROOT/$BLOGDIR | wc -l`
		if [ $START -gt $TOTAL ] || [ $START -eq $TOTAL ]; then
			TMP=`expr $START - $TOTAL`
			HEAD=`expr $COUNT - $TMP`
		else
			HEAD=$COUNT
		fi
		if [ "$REVERSE" == "okay" ]; then
			ENTRIES=`ls -1r $ROOT/$BLOGDIR | tail -n $START | head -n $HEAD`
		else
			ENTRIES=`ls -1r $ROOT/$BLOGDIR | head -n $START | tail -n $HEAD`
		fi

		for entry in $ENTRIES; do
			echo "<hr>"
			cat $ROOT/$BLOGDIR/$entry
			if [ "$COMMENTED" == "okay" ]; then
				comment_link $entry
				do_comments $entry
			fi
		done

		next $START

	elif [ "$TYPE" == "search" ]; then
		SEARCHTERMTMP=$(parse_val $REQUEST "term")
		SEARCHTERM=$(decode $SEARCHTERMTMP)		
        if [ -z $SEARCHTERM ]; then
			echo "<hr>No search term provided."
			exit
			fi
		SEARCHTERM=`echo $SEARCHTERM | tr + " "`
		SEARCHTERM=`echo $SEARCHTERM | sed 's/%3[Ee]/>/'`
		SEARCHTERM=`echo $SEARCHTERM | sed 's/%3[Cc]/</'`
		echo "<h4>Search results for \"$SEARCHTERM\"</h4>"

		RESULT=`grep -lr  "$SEARCHTERM" $ROOT/$BLOGDIR | sort -r 2>/dev/null`

		if [ "$RESULT" != "" ]; then
			for entry in $RESULT; do
				if [ $entry == $ROOT/$BLOGDIR/.head ]; then
					continue
					fi
				echo "<hr>"
				cat $entry
				done
		else
			echo "<h4>No results in search</h4>"
		fi

	elif [ "$TYPE" == "entry" ]; then
        FNAME=$(parse_val $REQUEST "fname")
		COMMENT=$(parse_val $REQUEST "comment")
echo "<form method=\"get\" action=\""$CGI"\">
<input type=\"hidden\" name=\"mode\" value=\"blog\" >
<input type=\"hidden\" name=\"dir\" value=\""$BLOGDIR"\" >
<input type=\"hidden\" name=\"fname\" value=\""$FNAME"\" >
<input type=\"hidden\" name=\"type\" value=\"write\" ><hr>"
		if [ "$COMMENT" != "" ]; then
				echo "<input type=\"hidden\" name=\"comment\" value=\""$COMMENT"\" >
<h4>New Comment for "$COMMENT"</h4>
<p>Only one comment per post per IP address allowed.
<br>A second comment overwrites the first. No links."
		fi

		echo "<p>POSTS:<br>
Posts limited to 500 words (size of textarea).<br>"

        if [ -n "$PRE" ]; then
            echo "No HTML tags. HTML entities okay.<br>"
        else
            echo "You can use HTML<br>"
        fi

        echo "<p>ERRORS:<br>
If you make a mistake, go back with the browser and edit it."

		if [ "$ACCESS" == "yes" ]; then 
			echo "<p>NOTE: You will not be able to edit your first 
post or comment on this blog."
		fi

	if [ "$LINK" == "okay" ] && [ -z "$COMMENT" ]; then
		echo "<p>DEFINITIONS:
<br>Posts are linked to all definitions of all defined terms.
<br>If you are defining a (lower-cased) word for others to refer to,
<br>bracket it like this: ,;;word;;, "
	fi

	if [ -z "$COMMENT" ]; then
		echo "<p>Enter a title for your post.
<p><input type=\"text\" name=\"title\" size=\"32\" maxlength=\"80\">"
		fi
		echo "<p align=\"left\"><textarea name=\"content\" rows=\"33\" cols=\"75\">
</textarea>
<p>Just to make sure you are actually here, if January is 01
and February is 02, what month is it now? <input type=\"text\"
name=\"month\" size=\"2\" maxlength=\"2\">
<p><input type=\"submit\" value=\"Submit\"></form>"

	elif [ "$TYPE" == "write" ]; then
		if [ "$COMMENTED" == "okay" ]; then
			COMMENT=$(parse_val $REQUEST "comment")
		fi
		if [ -z "$COMMENT" ] && [ "$OPEN" != "okay" ]; then
			echo "<hr><p>No Orcs Allowed."
			exit
		fi
		MONTH=$(parse_val $REQUEST "month")
		if [ "$MONTH" != `date +%m` ]; then
			echo "<hr>Wrong month.<br>Entry Cancelled."
			exit
		fi
		TEXT=$(parse_val $REQUEST "content")
		for spam in $SPAM; do
			KILL=`echo $TEXT | grep $spam 2>/dev/null`
			if [ "$KILL" != "" ]; then
				echo "<hr>Unacceptable Content.<br>Entry Cancelled."
				exit
			    fi
			done
		if [ -n "$PRE" ]; then
	    		HTML=`echo $TEXT | awk 'BEGIN { RS = "\a" } ; \
	    			{ if ($0 ~ /\%3C/) print "FOUND"  } '`
	        fi
		LEN=`echo $TEXT | awk 'BEGIN { RS = "\a" } ; \
				{ if (length($0) < 2500) print length($0); else print "BAD" } '`
		if [ "$HTML" == "FOUND" ]; then
			echo "<hr>No HTML tags permitted.<br>Entry Cancelled."
		elif [ "$LEN" == "BAD" ]; then
			echo "<hr>Submission over 2500 bytes.<br>Entry Cancelled."
		else
			STAMP=`date +%D`
			NAME=$(parse_val $REQUEST "title")
			TITLE=$(decode $NAME)
			OLDTITLE=$TITLE
			if [ "$OLDTITLE" == "" ]; then
				OLDTITLE="Comment - "$REMOTE
			fi
            if [ -n "$TEMPLATE" ]; then
                TITLE="<p class=\""$CLASS"\">"$TITLE" - "$STAMP"</p>"
            else
                TITLE="<h4>"$TITLE" - "$STAMP"</h4>"
            fi
			if [ "$COMMENT" == "" ]; then
                FNAME=$(parse_val $REQUEST "fname")
			else
				FNAME=".comments/"$COMMENT$REMOTE
				TITLE="<h5>Comment "$STAMP"</h5>"
			fi
			OWNER=`grep Posted $ROOT/$BLOGDIR/$FNAME 2>/dev/null`
			OWNED=`echo $OWNER | awk 'BEGIN { RS = "\a" } ; \
	    		{ if ($0 ~ $REMOTE) print "OK"  } '`
			if [ "$OWNED" != "OK" ]; then
				echo "<p>Attempted edit by non-owner."
				exit
			fi
			PAGE=$BLOGDIR/$FNAME
			TEXT=$(decode $TEXT)
			if [ -n "$PRE" ]; then
		                TEXT="<small><pre>\r"$TEXT"\r</pre></small>"
            		fi
			TEXT=$TITLE$TEXT"
<p>Posted by "$REMOTE
			# write to file
			echo -e $TEXT | awk 'BEGIN { RS = "\r" } \
				{   gsub("\r", "\n") ;
					print $0
				}' | fold -s -w 80 > $ROOT/$PAGE

        do_posts

		# blink's log
		echo "<br><a href="$CGI"?mode=admin&type=view&page="$PAGE">"$OLDTITLE"</a>
<br><a href="$CGI"?mode=admin&type=access&ip="$REMOTE"&page="$PAGE">add to access list</a>
<br><a href="$CGI"?mode=admin&type=delete&page="$PAGE">delete</a>" >> $LOG
		# blinklinks
		if [ "$LINK" == "okay" ]; then
			# list defined terms
			DEFINED=`grep b\\>[a-zA-Z]*\\</b $ROOT/$BLOGDIR/* 2>/dev/null`
			DEFINED=`echo $DEFINED | awk 'BEGIN { RS = "<b>" } \
				{ \
				if (index($0, "</b>") > 0) { \
				split($0, tmp, "</b>"); \
				print tmp[1]; \
				}; \
			}'`

			#mark defined
			awk '{ \
				if ($0 ~ /,;;[A-Za-z]*;;,/)  { \
				gsub(/,;;/, "<b>"); \
				gsub(/;;,/, "</b>"); \
				} \
				print ;
			} ' <$ROOT/$PAGE >tmp$$
			mv tmp$$ $ROOT/$PAGE

			#link all to defined
			for word in $DEFINED; do
				sed 's|'$word'|<a href="'$CGI'?mode=blog\&dir='$BLOGDIR'\&type=search\&term=%3E'$word'%3C"> '$word' </a>|g' < $ROOT/$PAGE > tmp$$
				mv tmp$$ $ROOT/$PAGE
				done
		fi


		despam

    fi


	else # default displays entries
        do_posts
	fi

elif [ "$MODE" == "admin" ]; then
    ADMIN=`echo $SELF | awk 'BEGIN { RS = " " }; \
	{  if ( index( "'$REMOTE'", $0 ) == 1 ) { print "okay"; exit } }'`
    if [ "$ADMIN" != "okay" ]; then
		echo "No Goblins Allowed"
	elif [ "$TYPE" == "view" ]; then
    	        PAGE=$(parse_val $REQUEST "page")
		echo "<h4>Viewing "$PAGE"</h4>"
		cat $ROOT/$PAGE
	elif [ "$TYPE" == "access" ]; then
	        IP=$(parse_val $REQUEST "ip")
			IP=$(decode $IP)		
			echo $IP >> ./access.lst
			TMP=`grep -v ^$IP$ ./once`
			echo $TMP | awk '{ gsub(" ", "\n" ) ; print}' > ./once
			echo "added "$IP" to access list"
	elif [ "$TYPE" == "delete" ]; then
	        PAGE=$(parse_val $REQUEST "page")
	        PAGE=`echo $PAGE | tr -d "?*"`
		echo "deleting "$PAGE
		rm $ROOT/$PAGE || echo " - deletion failed"
	elif [ "$TYPE" == "cull" ]; then
   		echo "<html><body>
<h4>Culling $BLOG</h4>"
		
		ENTRIES=`ls $ROOT/$BLOGDIR`
		for e in $ENTRIES; do
			echo "<br><a href="$CGI"?mode=admin&type=view&page="$BLOGDIR/$e">"$e"</a> - <a href="$CGI"?mode=admin&type=delete&page="$BLOGDIR/$e">delete</a>"
		done
  
	elif [ "$TYPE" == "archive" ]; then
		tar cjf $TARBALL_DIR/blink.tar.bz2 $ROOT && \
			echo "blink archived" || echo "archive failed"
    else
		echo "<title>"$LOG"</title>
		<h4>"$LOG"</h4>
		`date +%c`<hr><pre>"
		echo "   - end of data - " >> $LOG
		cat $LOG && rm $LOG
		echo "</pre><p><a href=\""$CGI"?mode=admin&type=archive\">Archive</a> all entries?"
	fi
	exit # skip bottom in admin mode

else #no mode
	BLOGS=`ls $ROOT`
	echo "<hr><h4>Available Blogs</h4><ul>"
	for blog in $BLOGS; do
	    NAME=`echo $blog | tr + " "`
		echo "<li><a href="$CGI"?mode=blog&dir="$blog">"$NAME"</a>"
		done
	echo "</ul><hr>"
	exit

fi
# bottom
    echo "<hr><form method=\"get\" action=\""$CGI"\">
<p>Search this blog for
<input type=\"hidden\" name=\"mode\" value=\"blog\">
<input type=\"hidden\" name=\"dir\" value=\""$BLOGDIR"\">
<input type=\"hidden\" name=\"type\" value=\"search\">
<input type=\"text\" name=\"term\" size=\"16\" maxlength=\"32\">
</form>"
    if [ "$TAGS" == "true" ]; then
		echo "<hr><h4>Tags</h4>"
		HASH=`grep -o \#[A-Za-z0-9]* $ROOT/$BLOGDIR/* | cut -d : -f 2 | sort | uniq 2>/dev/null`
		a=0
		for h in $HASH; do
			TMP=`echo $h | grep \\# | tr -d \# 2>/dev/null` 
			if [ "$TMP" != "" ]; then
				hashes[a++]=$TMP
				fi
			done
		for ((b=0; b <= a ; b++))
		do
			echo "| <a href="$CGI"?mode=blog&dir="$BLOGDIR"&type=search&term=%23"${hashes[b]}">"${hashes[b]}"</a>"
			done
		echo " <hr>"
		fi

    if [ "$OPEN" == "okay" ]; then
        FNAME=`date +%s`
        echo "<p>This is an open blog.
Submit a <a href="$CGI"?mode=blog&dir="$BLOGDIR"&type=entry&fname="$FNAME" >post</a>."
    fi

if [ -n "$TEMPLATE" ]; then
    cat $ROOT/$BLOGDIR/.tail
else
    echo "<p>Get your own copy of <a href="http://tinybashcgis.tuxfamily.org">Blink</a>.
<hr></body></html>"
fi
