#!/bin/bash
# fmra.cgi
# created and copyrighted: 29 Jan 11
# author: Evsiz (evsiz@this-voice.org)
# The author releases this file under the GNU GPL
# license. See GNU's COPYING file for specifics.
#
# uncomment if you have char problems
#set LANG=C
#export LANG

# User Consts
CGI=/cgi-bin/fmra.cgi
COUNT=102
LOG=fmra.log
PRE=""  # set to "true" or ""
REMOTE=$HTTP_X_CLUSTER_CLIENT_IP
ROOT=blink  # cgi-bin/blink
TEMPLATE="true" # set to "true" or ""
SELF="74.78.35.155 x"  # your IP used for admin access
TARBALL_DIR=data/private
CLASS="item" # css for post title

# space between elements - keep x at end of lists
BANNED_IPS=" x"
OPEN_BLOGS="ephemera test x" #public posts
REVERSED=" x" #oldest post first

if [ "$REMOTE" == "" ]; then REMOTE=$REMOTE_ADDR; fi
if [ -f .local  ]; then SELF="127.0.0.1 x";  fi

BANNED=`echo $BANNED_IPS | awk 'BEGIN { RS = " " }; { \
    if ( index( "'$REMOTE'", $0 ) == 1 ) { print "banned"; exit } }'`
if [ "$BANNED" == "banned" ]; then echo "No Orcs Allowed"; exit; fi

# methods

parse_val () {
    echo $1 | awk 'BEGIN { RS = "&" } ; \
	{ if (index($0, "'$2'") == 1) { split($0, tmp, "="); print tmp[2]; exit; }};'
}

decode () {
    arg=`echo $1 | awk '{
       gsub(/\%0D\%0A/, "\r") ;
       gsub(/\%0d\%0a/, "\r") ;
       gsub(/\x2B/, " ") ;
       gsub(/\x2b/, " ") ;
       print
    }'`
    i="0"
    while [ "$i" -lt ${#arg} ]; do
        c0=${arg:$i:1}
        if [ "x$c0" = "x%" ]; then
            c1=${arg:$((i+1)):1}
            c2=${arg:$((i+2)):1}
            printf "\x$c1$c2"
            i=$((i+3))
        else
            echo -n "$c0"
            i=$((i+1))
        fi
    done

}

do_posts () {
		if [ "$REVERSE" == "okay" ]; then
    	    EXIST=`ls -1r $ROOT/$BLOGDIR | wc -l`
	        if [ $EXIST -1r $COUNT ]; then COUNT=$EXIST; fi
			ENTRIES=`ls -1r $ROOT/$BLOGDIR | tail -n $COUNT`
			for ((a=$COUNT; a > 0; a--)); do
				entry=`echo $ENTRIES | cut -d" " -f $a`
				echo "<hr>"
				cat $ROOT/$BLOGDIR/$entry
				done
		else
			ENTRIES=`ls -1r $ROOT/$BLOGDIR | head -n $COUNT`
			for entry in $ENTRIES; do
				echo "<hr>"
				cat $ROOT/$BLOGDIR/$entry
				done
		fi
}


# start
REQUEST=`echo  "$REQUEST_URI" | cut -d"?" -f2 | tr -d "*" `
MODE=$(parse_val $REQUEST "mode")
BLOGDIR=$(parse_val $REQUEST "dir")
TYPE=$(parse_val $REQUEST "type")
BLOG=`echo $BLOGDIR | tr _ " "`
if [ "$BLOGDIR" == "" ] && [ "$MODE" == "blog" ]; then
    MODE="";
    TYPE="";
    TEMPLATE="";
    fi
if [ ! -d $ROOT/$BLOGDIR ] && [ "$MODE" == "blog" ]; then
    MODE="";
    TYPE="";
    TEMPLATE="";
    fi

REVERSE=`echo $REVERSED | awk 'BEGIN { RS = " " }; \
	{  if ( $0 ~ "'$BLOGDIR'" ) { print "okay"; exit } }'`
OPEN=`echo $OPEN_BLOGS | awk 'BEGIN { RS = " " }; \
	{  if ( $0 ~ "'$BLOGDIR'" ) { print "okay"; exit } }'`



# top
echo "Content-Type: text/html

"

if [ "$MODE" != "admin" ]; then

    NOW=`date +%s`
    ONEDAY=86400   # in seconds
    F=`ls -tr $ROOT/$BLOGDIR`
    for f in $F; do
        THEN=`stat -c%Y $ROOT/$BLOGDIR/$f`
        TIME=`expr $NOW - $THEN`
        if [ $TIME -gt $ONEDAY ]; then
            rm $ROOT/$BLOGDIR/$f
        else
            break
        fi
        done


    if [ -n "$TEMPLATE" ]; then
        cat $ROOT/$BLOGDIR/.head 2>/dev/null
        FNAME=`date +%s`
        echo "<p>
        <a href=\"/cgi-bin/fmra.cgi?mode=blog&dir=ephemera&type=entry&fname="$FNAME"\" >
        Say something real</a>.</div><div class=\"content\">"

    else
	    echo "<html><head>
<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />
<title>Ephemera :: "$BLOG"</title></head>
<body><h4>Ephemera :: <a href=\""$CGI"?mode=blog&dir=$BLOGDIR\">$BLOG</a></h4>"
        if [ -e $ROOT/$BLOGDIR/.header ]; then cat $ROOT/$BLOGDIR/.header; fi
    fi
fi

# middle
if [ "$MODE" == "blog" ]; then
	if [ "$TYPE" == "entry" ]; then
    FNAME=$(parse_val $REQUEST "fname")
echo "<form method=\"get\" action=\""$CGI"\">
<input type=\"hidden\" name=\"mode\" value=\"blog\" >
<input type=\"hidden\" name=\"dir\" value=\""$BLOGDIR"\" >
<input type=\"hidden\" name=\"fname\" value=\""$FNAME"\" >
<input type=\"hidden\" name=\"type\" value=\"write\" ><hr>"

		echo "<p>POSTS:<br>
Posts limited to about 200 words (size of textarea).<br>"

        if [ -n "$PRE" ]; then
            echo "No HTML tags. HTML entities okay.<br>"
        else
            echo "You can use HTML<br>"
        fi

        echo "<p>ERRORS:<br>
If you make a mistake, go back in the browser and fix it.

<p align=\"left\"><textarea name=\"content\" rows=\"25\" cols=\"36\">
</textarea>
<p>Just to make sure you are actually here, if January is 01
and February is 02, what month is it now?
<input type=\"text\" name=\"month\" size=\"2\" maxlength=\"2\">
 ::: <input type=\"submit\" value=\"Submit\"></form>"

	elif [ "$TYPE" == "write" ]; then
		if [ "$OPEN" != "okay" ]; then
			echo "<hr><p>No Orcs Allowed."
			exit
		fi
		MONTH=$(parse_val $REQUEST "month")
		if [ "$MONTH" != `date +%m` ]; then
			echo "<hr>Wrong month.<br>Entry Cancelled."
			exit
		fi
		TEXT=$(parse_val $REQUEST "content")
		if [ -n "$PRE" ]; then
	    		HTML=`echo $TEXT | awk 'BEGIN { RS = "\a" } ; \
	    			{ if ($0 ~ /\%3C/) print "FOUND"  } '`
	        fi
		LEN=`echo $TEXT | awk 'BEGIN { RS = "\a" } ; \
				{ if (length($0) < 1000) print "OK" } '`
		if [ "$HTML" == "FOUND" ]; then
			echo "<hr>No HTML tags permitted.<br>Entry Cancelled."
		elif [ "$LEN" != "OK" ]; then
			echo "<hr>Submission over 1000 bytes.<br>Entry Cancelled."
		else
			TITLE=`date +%A" "%R`
            if [ -n "$TEMPLATE" ]; then
                TITLE="<p class=\""$CLASS"\">"$TITLE"</p>"
            else
                TITLE="<h4>"$TITLE"</h4>"
            fi
            FNAME=$(parse_val $REQUEST "fname")
			PAGE=$BLOGDIR/$FNAME
			TEXT=$(decode $TEXT)
			if [ -n "$PRE" ]; then
		                TEXT="<small><pre>\r"$TEXT"\r</pre></small>"
            		fi
			TEXT=$TITLE$TEXT"<br>&nbsp;" 
			# write to file
			echo -e $TEXT | awk 'BEGIN { RS = "\r" } \
				{   gsub("\r", "\n") ;
					print $0
				}' | fold -s -w 80 > $ROOT/$PAGE
		# creation page
        do_posts

		# fmra's log
		    echo " </pre><br>
<a href="$CGI"?mode=admin&type=view&page="$PAGE">"$TITLE"</a> -
<a href="$CGI"?mode=admin&type=delete&page="$PAGE">delete</a>
Posted by "$REMOTE >> $LOG
    fi


	else # default displays entries
        do_posts
	fi

elif [ "$MODE" == "admin" ]; then
    ADMIN=`echo $SELF | awk 'BEGIN { RS = " " }; \
	{  if ( index( "'$REMOTE'", $0 ) == 1 ) { print "okay"; exit } }'`
    if [ "$ADMIN" != "okay" ]; then
		echo "No Goblins Allowed"
	elif [ "$TYPE" == "view" ]; then
    	        PAGE=$(parse_val $REQUEST "page")
		echo "<h4>Viewing "$PAGE"</h4>"
		cat $ROOT/$PAGE
	elif [ "$TYPE" == "delete" ]; then
	        PAGE=$(parse_val $REQUEST "page")
	        PAGE=`echo $PAGE | tr -d "?*"`
		echo "deleting "$PAGE
		rm $ROOT/$PAGE || echo " - deletion failed"
	elif [ "$TYPE" == "archive" ]; then
		tar cjf $TARBALL_DIR/fmra.tar.bz2 $ROOT && \
			echo "fmra archived" || echo "archive failed"
    else
		echo "<title>"$LOG"</title>
		<h4>"$LOG"</h4>
		`date +%c`<hr><pre>"
		echo "   - end of data - " >> $LOG
		cat $LOG && rm $LOG
		echo "</pre><p><a href=\""$CGI"?mode=admin&type=archive\">Archive</a> all entries?"
	fi
	exit # skip bottom in admin mode

else #no mode
	echo "<p>No blog selected. Are you lost?"
	exit

fi
# bottom

if [ -n "$TEMPLATE" ]; then
    cat $ROOT/$BLOGDIR/.tail
else
    if [ "$OPEN" == "okay" ]; then
        echo "<p>This is an open blog.
Submit a <a href="$CGI"?mode=blog&dir="$BLOGDIR"&type=entry >post</a>."
    fi
    echo "<p>Get your own copy of <a href="http://tinybashcgis.tuxfamily.org">Ephemera</a>.
<hr></body></html>"
fi
